Index: uspace/srv/hid/compositor/compositor.c
===================================================================
--- uspace/srv/hid/compositor/compositor.c	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/srv/hid/compositor/compositor.c	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -1985,5 +1642,5 @@
 		event->data.kbd.c = c;
 
-		comp_post_event_top(event);
+		comp_post_event(event);
 	}
 
@@ -2036,5 +1693,5 @@
 static void input_disconnect(void)
 {
-	pointer_t *pointer = input->user;
+    	pointer_t *pointer = input->user;
 	input_close(input);
 	pointer_destroy(pointer);
@@ -2049,5 +1706,5 @@
 {
 	/* Coordinates of the central pixel. */
-	coord_origin = UINT32_MAX / 4;
+	coord_origin = UINT32_MAX / 2;
 	
 	/* Color of the viewport background. Must be opaque. */
Index: uspace/srv/hid/compositor/compositor.h
===================================================================
--- uspace/srv/hid/compositor/compositor.h	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/srv/hid/compositor/compositor.h	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -43,11 +43,4 @@
 typedef desktop_point_t desktop_vector_t;
 
-typedef struct {
-	desktop_coord_t x;
-	desktop_coord_t y;
-	desktop_coord_t w;
-	desktop_coord_t h;
-} desktop_rect_t;
-
 /* TODO remove? */
 typedef struct {
Index: uspace/srv/hid/input/Makefile
===================================================================
--- uspace/srv/hid/input/Makefile	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/srv/hid/input/Makefile	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -35,5 +35,4 @@
 	layout/us_qwerty.c \
 	layout/us_dvorak.c \
-	layout/ar.c \
 	port/adb.c \
 	port/adb_mouse.c \
Index: uspace/srv/hid/input/ctl/kbdev.c
===================================================================
--- uspace/srv/hid/input/ctl/kbdev.c	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/srv/hid/input/ctl/kbdev.c	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -37,5 +37,5 @@
 
 #include <async.h>
-#include <stdbool.h>
+#include <bool.h>
 #include <errno.h>
 #include <fcntl.h>
Index: uspace/srv/hid/input/input.c
===================================================================
--- uspace/srv/hid/input/input.c	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/srv/hid/input/input.c	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -38,5 +38,5 @@
 
 #include <adt/list.h>
-#include <stdbool.h>
+#include <bool.h>
 #include <fibril_synch.h>
 #include <ipc/services.h>
@@ -62,11 +62,10 @@
 #include "input.h"
 
-#define NUM_LAYOUTS  4
+#define NUM_LAYOUTS  3
 
 static layout_ops_t *layout[NUM_LAYOUTS] = {
 	&us_qwerty_ops,
 	&us_dvorak_ops,
-	&cz_ops,
-	&ar_ops
+	&cz_ops
 };
 
@@ -161,11 +160,4 @@
 		layout_destroy(kdev->active_layout);
 		kdev->active_layout = layout_create(layout[2]);
-		return;
-	}
-	
-	if (type == KEY_PRESS && (kdev->mods & KM_LCTRL) &&
-	    key == KC_F4) {
-		layout_destroy(kdev->active_layout);
-		kdev->active_layout = layout_create(layout[3]);
 		return;
 	}
@@ -431,4 +423,10 @@
 	kbd_add_dev(&chardev_port, &stty_ctl);
 #endif
+#if defined(UARCH_arm32) && defined(MACHINE_testarm) && defined(CONFIG_FB)
+	kbd_add_dev(&gxemul_port, &gxe_fb_ctl);
+#endif
+#if defined(UARCH_arm32) && defined(MACHINE_testarm) && !defined(CONFIG_FB)
+	kbd_add_dev(&gxemul_port, &stty_ctl);
+#endif
 #if defined(UARCH_arm32) && defined(MACHINE_integratorcp)
 	kbd_add_dev(&pl050_port, &pc_ctl);
Index: uspace/srv/hid/input/input.h
===================================================================
--- uspace/srv/hid/input/input.h	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/srv/hid/input/input.h	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -39,5 +39,5 @@
 #define INPUT_H_
 
-#include <stdbool.h>
+#include <bool.h>
 #include <async.h>
 
Index: uspace/srv/hid/input/layout.h
===================================================================
--- uspace/srv/hid/input/layout.h	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/srv/hid/input/layout.h	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -60,5 +60,4 @@
 extern layout_ops_t us_dvorak_ops;
 extern layout_ops_t cz_ops;
-extern layout_ops_t ar_ops;
 
 extern layout_t *layout_create(layout_ops_t *);
Index: uspace/srv/hid/input/layout/cz.c
===================================================================
--- uspace/srv/hid/input/layout/cz.c	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/srv/hid/input/layout/cz.c	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -35,5 +35,5 @@
 #include <io/console.h>
 #include <io/keycode.h>
-#include <stdbool.h>
+#include <bool.h>
 #include <stdlib.h>
 #include "../input.h"
Index: uspace/srv/hid/input/port/niagara.c
===================================================================
--- uspace/srv/hid/input/port/niagara.c	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/srv/hid/input/port/niagara.c	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -42,5 +42,5 @@
 #include <stdio.h>
 #include <thread.h>
-#include <stdbool.h>
+#include <bool.h>
 #include <errno.h>
 #include "../kbd_port.h"
Index: uspace/srv/hid/input/port/pl050.c
===================================================================
--- uspace/srv/hid/input/port/pl050.c	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/srv/hid/input/port/pl050.c	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -37,7 +37,9 @@
 
 #include <ddi.h>
+#include <libarch/ddi.h>
 #include <async.h>
 #include <unistd.h>
 #include <sysinfo.h>
+#include <ddi.h>
 #include <stdio.h>
 #include <errno.h>
Index: uspace/srv/hid/input/port/ski.c
===================================================================
--- uspace/srv/hid/input/port/ski.c	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/srv/hid/input/port/ski.c	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -40,5 +40,5 @@
 #include <sys/types.h>
 #include <thread.h>
-#include <stdbool.h>
+#include <bool.h>
 #include "../kbd_port.h"
 #include "../kbd.h"
Index: uspace/srv/hid/input/proto/adb.c
===================================================================
--- uspace/srv/hid/input/proto/adb.c	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/srv/hid/input/proto/adb.c	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -36,5 +36,5 @@
  */
 
-#include <stdbool.h>
+#include <bool.h>
 #include "../mouse.h"
 #include "../mouse_port.h"
Index: uspace/srv/hid/output/output.h
===================================================================
--- uspace/srv/hid/output/output.h	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/srv/hid/output/output.h	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -31,5 +31,5 @@
 
 #include <sys/types.h>
-#include <stdbool.h>
+#include <bool.h>
 #include <loc.h>
 #include <io/console.h>
Index: uspace/srv/hid/output/port/ega.c
===================================================================
--- uspace/srv/hid/output/port/ega.c	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/srv/hid/output/port/ega.c	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -36,4 +36,5 @@
 #include <as.h>
 #include <ddi.h>
+#include <libarch/ddi.h>
 #include <io/chargrid.h>
 #include "../output.h"
@@ -210,5 +211,6 @@
 		return rc;
 	
-	rc = pio_enable((void*)EGA_IO_BASE, EGA_IO_SIZE, NULL);
+	rc = iospace_enable(task_get_id(), (void *) EGA_IO_BASE,
+	    EGA_IO_SIZE);
 	if (rc != EOK)
 		return rc;
Index: uspace/srv/hid/s3c24xx_ts/s3c24xx_ts.c
===================================================================
--- uspace/srv/hid/s3c24xx_ts/s3c24xx_ts.c	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/srv/hid/s3c24xx_ts/s3c24xx_ts.c	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -38,4 +38,5 @@
 
 #include <ddi.h>
+#include <libarch/ddi.h>
 #include <loc.h>
 #include <io/console.h>
Index: uspace/srv/hw/bus/cuda_adb/cuda_adb.c
===================================================================
--- uspace/srv/hw/bus/cuda_adb/cuda_adb.c	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/srv/hw/bus/cuda_adb/cuda_adb.c	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -40,5 +40,5 @@
 #include <stdlib.h>
 #include <sys/types.h>
-#include <stdbool.h>
+#include <bool.h>
 #include <ddi.h>
 #include <libarch/ddi.h>
Index: uspace/srv/hw/char/s3c24xx_uart/s3c24xx_uart.c
===================================================================
--- uspace/srv/hw/char/s3c24xx_uart/s3c24xx_uart.c	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/srv/hw/char/s3c24xx_uart/s3c24xx_uart.c	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -38,4 +38,5 @@
 
 #include <ddi.h>
+#include <libarch/ddi.h>
 #include <loc.h>
 #include <ipc/char.h>
Index: uspace/srv/hw/irc/apic/apic.c
===================================================================
--- uspace/srv/hw/irc/apic/apic.c	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/srv/hw/irc/apic/apic.c	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -42,5 +42,5 @@
 #include <as.h>
 #include <ddi.h>
-#include <stdbool.h>
+#include <bool.h>
 #include <errno.h>
 #include <async.h>
Index: uspace/srv/hw/irc/i8259/i8259.c
===================================================================
--- uspace/srv/hw/irc/i8259/i8259.c	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/srv/hw/irc/i8259/i8259.c	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -42,6 +42,7 @@
 #include <as.h>
 #include <ddi.h>
+#include <libarch/ddi.h>
 #include <align.h>
-#include <stdbool.h>
+#include <bool.h>
 #include <errno.h>
 #include <async.h>
Index: uspace/srv/hw/irc/obio/obio.c
===================================================================
--- uspace/srv/hw/irc/obio/obio.c	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/srv/hw/irc/obio/obio.c	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -49,5 +49,5 @@
 #include <ddi.h>
 #include <align.h>
-#include <stdbool.h>
+#include <bool.h>
 #include <errno.h>
 #include <async.h>
Index: uspace/srv/loader/main.c
===================================================================
--- uspace/srv/loader/main.c	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/srv/loader/main.c	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -47,5 +47,5 @@
 #include <stdlib.h>
 #include <unistd.h>
-#include <stdbool.h>
+#include <bool.h>
 #include <fcntl.h>
 #include <sys/types.h>
Index: uspace/srv/locsrv/locsrv.c
===================================================================
--- uspace/srv/locsrv/locsrv.c	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/srv/locsrv/locsrv.c	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -42,5 +42,5 @@
 #include <stdio.h>
 #include <errno.h>
-#include <stdbool.h>
+#include <bool.h>
 #include <fibril_synch.h>
 #include <macros.h>
Index: uspace/srv/logger/initlvl.c
===================================================================
--- uspace/srv/logger/initlvl.c	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/srv/logger/initlvl.c	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -38,5 +38,4 @@
 #include <sysinfo.h>
 #include <str.h>
-#include <stdlib.h>
 #include "logger.h"
 
@@ -92,5 +91,4 @@
 	char level_str[200];
 	str_cpy(level_str, 200, (const char *) argument);
-	free(argument);
 
 	parse_level_settings(level_str);
Index: uspace/srv/logger/logger.h
===================================================================
--- uspace/srv/logger/logger.h	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/srv/logger/logger.h	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -40,5 +40,5 @@
 #include <io/log.h>
 #include <async.h>
-#include <stdbool.h>
+#include <bool.h>
 #include <fibril_synch.h>
 #include <stdio.h>
Index: uspace/srv/net/ethip/ethip_nic.c
===================================================================
--- uspace/srv/net/ethip/ethip_nic.c	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/srv/net/ethip/ethip_nic.c	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -37,5 +37,5 @@
 #include <adt/list.h>
 #include <async.h>
-#include <stdbool.h>
+#include <bool.h>
 #include <errno.h>
 #include <fibril_synch.h>
Index: uspace/srv/net/inetsrv/inet_link.c
===================================================================
--- uspace/srv/net/inetsrv/inet_link.c	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/srv/net/inetsrv/inet_link.c	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -35,5 +35,5 @@
  */
 
-#include <stdbool.h>
+#include <bool.h>
 #include <errno.h>
 #include <fibril_synch.h>
Index: uspace/srv/net/inetsrv/inetsrv.h
===================================================================
--- uspace/srv/net/inetsrv/inetsrv.h	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/srv/net/inetsrv/inetsrv.h	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -39,5 +39,5 @@
 
 #include <adt/list.h>
-#include <stdbool.h>
+#include <bool.h>
 #include <inet/iplink.h>
 #include <ipc/loc.h>
Index: uspace/srv/net/tcp/conn.c
===================================================================
--- uspace/srv/net/tcp/conn.c	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/srv/net/tcp/conn.c	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -36,5 +36,5 @@
 
 #include <adt/list.h>
-#include <stdbool.h>
+#include <bool.h>
 #include <errno.h>
 #include <io/log.h>
Index: uspace/srv/net/tcp/conn.h
===================================================================
--- uspace/srv/net/tcp/conn.h	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/srv/net/tcp/conn.h	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -36,5 +36,5 @@
 #define CONN_H
 
-#include <stdbool.h>
+#include <bool.h>
 #include "tcp_type.h"
 
Index: uspace/srv/net/tcp/seq_no.c
===================================================================
--- uspace/srv/net/tcp/seq_no.c	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/srv/net/tcp/seq_no.c	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -36,5 +36,5 @@
 
 #include <assert.h>
-#include <stdbool.h>
+#include <bool.h>
 #include <sys/types.h>
 #include "seq_no.h"
Index: uspace/srv/net/tcp/tcp_type.h
===================================================================
--- uspace/srv/net/tcp/tcp_type.h	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/srv/net/tcp/tcp_type.h	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -38,5 +38,5 @@
 #include <adt/list.h>
 #include <async.h>
-#include <stdbool.h>
+#include <bool.h>
 #include <fibril.h>
 #include <fibril_synch.h>
Index: uspace/srv/net/udp/assoc.c
===================================================================
--- uspace/srv/net/udp/assoc.c	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/srv/net/udp/assoc.c	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -36,5 +36,5 @@
 
 #include <adt/list.h>
-#include <stdbool.h>
+#include <bool.h>
 #include <fibril_synch.h>
 #include <io/log.h>
Index: uspace/srv/ns/clonable.c
===================================================================
--- uspace/srv/ns/clonable.c	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/srv/ns/clonable.c	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -34,5 +34,5 @@
 #include <ipc/services.h>
 #include <adt/list.h>
-#include <stdbool.h>
+#include <bool.h>
 #include <errno.h>
 #include <assert.h>
Index: uspace/srv/ns/clonable.h
===================================================================
--- uspace/srv/ns/clonable.h	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/srv/ns/clonable.h	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -36,5 +36,5 @@
 #include <ipc/common.h>
 #include <sys/types.h>
-#include <stdbool.h>
+#include <bool.h>
 
 extern int clonable_init(void);
Index: uspace/srv/ns/task.c
===================================================================
--- uspace/srv/ns/task.c	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/srv/ns/task.c	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -34,5 +34,5 @@
 #include <ipc/ipc.h>
 #include <adt/hash_table.h>
-#include <stdbool.h>
+#include <bool.h>
 #include <errno.h>
 #include <assert.h>
Index: uspace/srv/vfs/vfs.c
===================================================================
--- uspace/srv/vfs/vfs.c	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/srv/vfs/vfs.c	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -44,5 +44,5 @@
 #include <errno.h>
 #include <stdio.h>
-#include <stdbool.h>
+#include <bool.h>
 #include <str.h>
 #include <as.h>
Index: uspace/srv/vfs/vfs.h
===================================================================
--- uspace/srv/vfs/vfs.h	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/srv/vfs/vfs.h	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -40,5 +40,5 @@
 #include <sys/types.h>
 #include <loc.h>
-#include <stdbool.h>
+#include <bool.h>
 #include <ipc/vfs.h>
 #include <task.h>
Index: uspace/srv/vfs/vfs_file.c
===================================================================
--- uspace/srv/vfs/vfs_file.c	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/srv/vfs/vfs_file.c	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -40,5 +40,5 @@
 #include <str.h>
 #include <assert.h>
-#include <stdbool.h>
+#include <bool.h>
 #include <fibril.h>
 #include <fibril_synch.h>
Index: uspace/srv/vfs/vfs_lookup.c
===================================================================
--- uspace/srv/vfs/vfs_lookup.c	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/srv/vfs/vfs_lookup.c	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -42,5 +42,5 @@
 #include <str.h>
 #include <stdarg.h>
-#include <stdbool.h>
+#include <bool.h>
 #include <fibril_synch.h>
 #include <adt/list.h>
Index: uspace/srv/vfs/vfs_ops.c
===================================================================
--- uspace/srv/vfs/vfs_ops.c	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/srv/vfs/vfs_ops.c	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -44,5 +44,5 @@
 #include <stdlib.h>
 #include <str.h>
-#include <stdbool.h>
+#include <bool.h>
 #include <fibril_synch.h>
 #include <adt/list.h>
Index: uspace/srv/vfs/vfs_register.c
===================================================================
--- uspace/srv/vfs/vfs_register.c	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/srv/vfs/vfs_register.c	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -45,5 +45,5 @@
 #include <str.h>
 #include <ctype.h>
-#include <stdbool.h>
+#include <bool.h>
 #include <adt/list.h>
 #include <as.h>
